// tickertoggleleftclick.m
//
// Toggles songticker scrolling on/off by leftclicking on it.
//
// modified from tickertogglerightclick.m and first click fixed by Ariszló

//-----------------------------------------------------------------------------
// tickertogglerightclick.m
//
// created by Hammerhead aka Kabir Chanrai
// modded by Jimmysmith
//-----------------------------------------------------------------------------

//                            USING THIS SCRIPT:
//*****************************************************************************
//  1.  Define the following in your XML (or at least something similar):
//		  <Text
//			id="Songticker"
//			display="songname"
//			x="410" y="58"
//			w="36" h="93"
//			ticker="1"
//		  />
//      Change the position(x,y) and size(w,h) of "Songticker" to suit your
//		needs.
//  
//  2.  Copy this script (and tickertoggleleftclick.maki) to your scripts folder.
//  3.  If you don't have tickertoggleleftclick.maki, compile this script.
//  4.  Add this line to the group that contains your songticker
//
//        <script id="tickertoggle" file="scripts/tickertoggleleftclick.maki"/>
//
//  5.  Refresh your skin(F5) and try it out.
//*****************************************************************************

#include "lib/std.mi"  //Always include this in maki scripts.

Global Text Songticker;
Global Timer SongtickerRemainingTimer;
Global Boolean TickerIs;

System.onScriptLoaded(){   //What happens when the skin is loaded up/winamp is started?

group pGroup = getScriptGroup();   //This line MAKES a new group (pGroup) and gets the group.

Songticker = pGroup.getObject("Songticker");    //This line GETS the text object from pGroup.


  SongtickerRemainingTimer = new Timer;     //This line starts a new timer for the songticker text deleting (after scroll status has been set)
  SongtickerRemainingTimer.setDelay(500);     //This line makes the delay for the timer defined above.

/* Add this to fix first click */
if (!TickerIs) TickerIs = 1;
}

Songticker.OnLeftButtonup(int X, int Y) //What happens when you click the button SongtickerFaketoClick?
{ 
if (TickerIs) {   //Opens up the boolean.

SongTicker.setXMLParam("Ticker","0");   //Sets the xml param 'ticker' (this toggles scrolling off).

songticker.setText("Scrolling: OFF");     //Tells the text to display 'Scrolling: OFF' when the boolean 'tickeris' is at state 0.
SongtickerRemainingTimer.start();      //Starts the timer which will delete the line that is being displayed by the songticker (defined above)

TickerIs = 0;      //Tells the compiler that this state of the boolean is the off state, or 0.

} else {       //What if the boolean is not at state 1, but 0?

SongTicker.setXMLParam("Ticker","1");    //Sets the xml param 'ticker' (this toggles scrolling on).

songticker.setText("Scrolling: ON");     //Tells the text to display 'Scrolling: ON' when the boolean 'tickeris' is at state 1.
SongtickerRemainingTimer.start();       //Starts the timer which will delete the line that is being displayed by the songticker (defined above)

TickerIs = 1;      //Tells the compiler that this state of the boolean is the on state, or 1.
} 
complete;
} 

SongtickerRemainingTimer.onTimer() {      //What happens when the timer 'SongtickerRemainingTimer's delay finishes? (SongtickerRemainingTimer is the timer that is started when we want the songticker text area set back to its original display.

SongTicker.setText("");      //Sets the ticker text to nothing.

}

System.onScriptUnloading(){        //What happens when you switch skin or close winamp?

delete SongtickerRemainingTimer;       //Delete the timer.

}
